/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*               EPI Pomdapi, INRIA Paris - Rocquencourt               */
/*                                                                     */
/*  Copyright 2005-2014 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: global.cpp,v 1.9 2014/01/10 19:22:09 fclement Exp $ */

#include "global.hpp"

namespace io{
  
  //singleton patterns 
  //(see for example S.Meyers. Effective C++. Addison-Weisley, 1998 - P 222)
  
  bool& binary(){
    static bool _binary=true;
    return _binary;
  }
  
  bool& reception_binary(){
    static bool _reception_binary=true;
    return _reception_binary;
  }
  
  unsigned int& width(){
    static unsigned int _width=23;
    return _width;
  }
  
  unsigned int& prec(){
    static unsigned int _prec=16;
    return _prec;
  }
  
  void set_binary(){
    binary() = true;
  }
  void set_ascii(){
    binary() = false;
  }
  void set_reception_binary(){
    reception_binary() = true;
  }
  void set_reception_ascii(){
    reception_binary() = false;
  }
  
  
  void set_width(unsigned int i){
    width() = i;
  }
  
  unsigned int get_width(){
    return width();
  }
  
  
  void set_prec(unsigned int i){
    prec() = i;
  }
  
  unsigned int get_prec(){
    return prec();
  }
  
  bool get_binary(){
    return binary();
  }
  
  bool get_reception_binary(){
    return reception_binary();
  }
 
  bool& debug(){
    static bool _debug=false;
    return _debug;
  }
  bool get_debug(){
    return debug();
  }
  void set_debug(){
    debug() = true;
  }
  void unset_debug(){
    debug() = false;
  }

}
