(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: history.ml,v 1.9 2014/05/06 12:56:21 fclement Exp $ *)

module Config = Configuration;;

open Scalar_spec;;
open Components_spec;;

module Make =
  functor (Scal : SCALAR) ->
  functor (Comps : COMPONENTS) ->
struct
  module St = State.Make (Scal) (Comps);;
  module Bb = St.Bb;;
  
  include Uhistory.Make (Config) (St);;
  
  (* Early parse of the command line to get the parameter size before
   setting up graphical capabilities when applying Display.Make functor. *)
  let h_init = initialization ();;
end
;;
