CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright (c) 2013-2014 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: gradient12.f,v 1.6 2014/05/12 14:43:23 fclement Exp $

      subroutine gradient12 (n1,ndS,ndT,S,T,gdS,gdT)
c     
      implicit integer (z)
      implicit real*8 (t,f,d)
c     
      include 'common.fh'
c
      integer n1,ndS,ndT
      dimension S(ndS), T(ndT), gdS(ndS), gdT(ndT)
      real*8 S, T
      real*8 gdS, gdT
      integer nbequation
      integer i,j,n
      integer ii,irr
c     
      n = 2*n1-1
      do   i   =   1   ,   nszz   ,   1
         ssmbz(i) = -gdu(i,n)
      enddo
c     ***************************************************************
      j = 1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
      enddo
c     .....................
      i = j*nx
      ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     .....................
      i = nx*(ny+1)+(j-1)*nx+1
      ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     .....................
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
      enddo
c     .....................
      i = nx*(ny+1)+j*nx
      ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     ---------------------------------------------------------------
      do   j   =   2   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
         enddo
c     .....................
         i = j*nx
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     .....................
         i = nx*(ny+1)+(j-1)*nx+1
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     .....................
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
         enddo
c     .....................
         i = nx*(ny+1)+j*nx
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
      enddo
c     ---------------------------------------------------------------
      j = ny+1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
      enddo
c     .....................
      i = j*nx
      ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
c     ***************************************************************
c     RESOLUTION du SYSTEME LINEAIRE
      nbequation = nx*(ny+1)+nx*ny
      if (n.eq.(2*nt-1)) then
         call rslnag12(ndS,ndT,S,T,n,0,nbequation)
      else
         call rslnag12(ndS,ndT,S,T,n,1,nbequation)
      endif
      do   i   =   1   ,   nszz   ,   1
         smbz(i,1) = smbz(i,4)
         smbz(i,2) = smbz(i,5)
         smbz(i,3) = 0
      enddo
c     ***************************************************************
      j = 1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         ii = i
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(i,3)*fT(ndT,T,i)
     &        *fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*vvzz(i)
      enddo
c     .....................
      i = j*nx
      ii = i
      smbz(ii,3) = smbz(ii,3)
     &     +falphaa(i,3)*fT(ndT,T,i)
     &     *fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*vvzz(i)
c     .....................
      i = nx*(ny+1)+(j-1)*nx+1
c     .....................
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         ii = i-nx*ny-nx-1
         zt3 = i-nx*ny-nx-1
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt3,2)*fT(ndT,T,zt3)
     &        *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
         ii = i-nx*ny-nx
         zt3 = i-nx*ny-nx
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt3,1)*fT(ndT,T,zt3)
     &        *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
      enddo
c     .....................
      i = nx*(ny+1)+j*nx
      ii = i-nx*ny-nx-1
      zt3 = i-nx*ny-nx-1
      smbz(ii,3) = smbz(ii,3)
     &     +falphaa(zt3,2)*fT(ndT,T,zt3)
     &     *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
      ii = i-nx*ny-nx
      zt3 = i-nx*ny-nx
      smbz(ii,3) = smbz(ii,3)
     &     +falphaa(zt3,1)*fT(ndT,T,zt3)
     &     *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
c     ---------------------------------------------------------------
      do   j   =   2   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            ii = i
            smbz(ii,3) = smbz(ii,3)
     &           +falphaa(i,3)*fT(ndT,T,i)
     &           *fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*vvzz(i)
            ii = i-nx
            zt2 = i-nx
            smbz(ii,3) = smbz(ii,3)
     &           +falphaa(zt2,4)*fT(ndT,T,zt2)
     &           *fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*vvzz(i)
         enddo
c     .....................
         i = j*nx
         ii = i
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(i,3)*fT(ndT,T,i)
     &        *fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*vvzz(i)
         ii = i-nx
         zt2 = i-nx
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt2,4)*fT(ndT,T,zt2)
     &        *fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*vvzz(i)
c     .....................
         i = nx*(ny+1)+(j-1)*nx+1
c     .....................
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            ii = i-nx*ny-nx-1
            zt3 = i-nx*ny-nx-1
            smbz(ii,3) = smbz(ii,3)
     &           +falphaa(zt3,2)*fT(ndT,T,zt3)
     &           *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
            ii = i-nx*ny-nx
            zt3 = i-nx*ny-nx
            smbz(ii,3) = smbz(ii,3)
     &           +falphaa(zt3,1)*fT(ndT,T,zt3)
     &           *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
         enddo
c     .....................
         i = nx*(ny+1)+j*nx
         ii = i-nx*ny-nx-1
         zt3 = i-nx*ny-nx-1
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt3,2)*fT(ndT,T,zt3)
     &        *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
         ii = i-nx*ny-nx
         zt3 = i-nx*ny-nx
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt3,1)*fT(ndT,T,zt3)
     &        *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*vvzz(i)
      enddo
c     ---------------------------------------------------------------
      j = ny+1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         ii = i-nx
         zt2 = i-nx
         smbz(ii,3) = smbz(ii,3)
     &        +falphaa(zt2,4)*fT(ndT,T,zt2)
     &        *fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*vvzz(i)
      enddo
c     .....................
      i = j*nx
      ii = i-nx
      zt2 = i-nx
      smbz(ii,3) = smbz(ii,3)
     &     +falphaa(zt2,4)*fT(ndT,T,zt2)
     &     *fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*vvzz(i)
c     ***************************************************************
      do   i   =   1   ,   nszz   ,   1
         smbz(i,4) = smbz(i,6)
         smbz(i,5) = 0
      enddo
c     ***************************************************************
      j = 1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         t2 = sigma*fT(ndT,T,i)*vvzz(i)
         ii = i
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)*t2
         ii = nx*ny+nx+i
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)*t2
         ii = nx*ny+nx+i+1
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)*t2
         ii = i+nx
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)*t2
      enddo
c     .....................
      i = j*nx
      t2 = sigma*fT(ndT,T,i)*vvzz(i)
      ii = i
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)*t2
      ii = nx*ny+nx+i
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)*t2
      ii = i+nx
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)*t2
c     .....................
      i = nx*(ny+1)+(j-1)*nx+1
c     .....................
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         t3 = vvzz(i)*sigma
         zt5 = i-nx*ny-nx-1
         t5 = fT(ndT,T,zt5)
         zt10 = i-nx*ny-nx
         t10 = fT(ndT,T,zt10)
         ii = i-nx*ny-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,4,dt,dx,dy,theta)*t5
         ii = i-nx*ny-nx-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,3,dt,dx,dy,theta)*t5
         ii = i-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,1,dt,dx,dy,theta)*t5
         ii = i-nx*ny-nx
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,3,dt,dx,dy,theta)*t10
         ii = i-nx*ny
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,4,dt,dx,dy,theta)*t10
         ii = i+1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,2,dt,dx,dy,theta)*t10
         ii = i
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,2,dt,dx,dy,theta)*t5
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,1,dt,dx,dy,theta)*t10
      enddo
c     .....................
      i = nx*(ny+1)+j*nx
      t3 = sigma*vvzz(i)
      zt5 = i-nx*ny-nx-1
      t5 = fT(ndT,T,zt5)
      zt10 = i-nx*ny-nx
      t10 = fT(ndT,T,zt10)
      ii = i-nx*ny-1
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt5,2,4,dt,dx,dy,theta)*t5
      ii = i-nx*ny-nx-1
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt5,2,3,dt,dx,dy,theta)*t5
      ii = i-1
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt5,2,1,dt,dx,dy,theta)*t5
      ii = i-nx*ny-nx
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt10,1,3,dt,dx,dy,theta)*t10
      ii = i-nx*ny
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt10,1,4,dt,dx,dy,theta)*t10
      ii = i
      smbz(ii,5) = smbz(ii,5)
     &     +t3*fnu(ndS,S,ndT,T,zt5,2,2,dt,dx,dy,theta)*t5
     &     +t3*fnu(ndS,S,ndT,T,zt10,1,1,dt,dx,dy,theta)*t10
c     ---------------------------------------------------------------
      do   j   =   2   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            t4 = fT(ndT,T,i)
            t3 = vvzz(i)*sigma
            zt4 = i-nx
            t2 = fT(ndT,T,zt4)
            ii = i-nx
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt4,4,3,dt,dx,dy,theta)*t2
            ii = nx*ny+i
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt4,4,1,dt,dx,dy,theta)*t2
            ii = nx*ny+i+1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt4,4,2,dt,dx,dy,theta)*t2
            ii = nx*ny+nx+i
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)*t4
            ii = nx*ny+nx+i+1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)*t4
            ii = i+nx
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)*t4
            ii = i
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt4,4,4,dt,dx,dy,theta)*t2
     &           +t3*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)*t4
         enddo
c     .....................
         i = j*nx
         t3 = vvzz(i)*sigma
         zt2 = i-nx
         t2 = fT(ndT,T,zt2)
         t4 = fT(ndT,T,i)
         ii = i-nx
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)*t2
         ii = nx*ny+i
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)*t2
         ii = nx*ny+nx+i
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)*t4
         ii = i+nx
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)*t4
         ii = i
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)*t2
     &        +t3*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)*t4
c     .....................
         i = nx*(ny+1)+(j-1)*nx+1
c     .....................
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            t3 = vvzz(i)*sigma
            zt5 = i-nx*ny-nx-1
            t5 = fT(ndT,T,zt5)
            zt10 = i-nx*ny-nx
            t10 = fT(ndT,T,zt10)
            ii = i-nx*ny-1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt5,2,4,dt,dx,dy,theta)*t5
            ii = i-nx*ny-nx-1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt5,2,3,dt,dx,dy,theta)*t5
            ii = i-1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt5,2,1,dt,dx,dy,theta)*t5
            ii = i-nx*ny-nx
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt10,1,3,dt,dx,dy,theta)*t10
            ii = i-nx*ny
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt10,1,4,dt,dx,dy,theta)*t10
            ii = i+1
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt10,1,2,dt,dx,dy,theta)*t10
            ii = i
            smbz(ii,5) = smbz(ii,5)
     &           +t3*fnu(ndS,S,ndT,T,zt5,2,2,dt,dx,dy,theta)*t5
     &           +t3*fnu(ndS,S,ndT,T,zt10,1,1,dt,dx,dy,theta)*t10
         enddo
c     .....................
         i = nx*(ny+1)+j*nx
         t3 = vvzz(i)*sigma
         zt5 = i-nx*ny-nx-1
         t5 = fT(ndT,T,zt5)
         zt10 = i-nx*ny-nx
         t10 = fT(ndT,T,zt10)
         ii = i-nx*ny-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,4,dt,dx,dy,theta)*t5
         ii = i-nx*ny-nx-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,3,dt,dx,dy,theta)*t5
         ii = i-1
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,1,dt,dx,dy,theta)*t5
         ii = i-nx*ny-nx
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,3,dt,dx,dy,theta)*t10
         ii = i-nx*ny
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,4,dt,dx,dy,theta)*t10
         ii = i
         smbz(ii,5) = smbz(ii,5)
     &        +t3*fnu(ndS,S,ndT,T,zt5,2,2,dt,dx,dy,theta)*t5
     &        +t3*fnu(ndS,S,ndT,T,zt10,1,1,dt,dx,dy,theta)*t10
      enddo
c     ---------------------------------------------------------------
      j = ny+1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         zt2 = i-nx
         t3 = sigma*fT(ndT,T,zt2)*vvzz(i)
         ii = i
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)*t3
         ii = i-nx
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)*t3
         ii = nx*ny+i
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)*t3
         ii = nx*ny+i+1
         smbz(ii,5) = smbz(ii,5)
     &        +fnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta)*t3
      enddo
c     .....................
      i = j*nx
      zt2 = i-nx
      t3 = sigma*fT(ndT,T,zt2)*vvzz(i)
      ii = i
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)*t3
      ii = i-nx
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)*t3
      ii = nx*ny+i
      smbz(ii,5) = smbz(ii,5)
     &     +fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)*t3
      do   i   =   1   ,   nszz   ,   1
         smbz(i,6) = 0
      enddo
c     ***************************************************************
      j = 1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         t1 = vvzz(i)
         t2 = falphaa(i,3)
         t4 = fT(ndT,T,i)
         t10 = falphak(i)
         t25 = t1*t4*t10
         t25sig = t25*sigma
         t25thet = t25*theta
         zt28 = i+nx
         zt29 = n-2
         zt49 = nx*(ny+1)
         zt50 = zt49+i
         zt60 = zt49+i+1
         do   irr   =   1   ,   ndS   ,   1
            t14 = t1*dSfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
            t26 = dSfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
            t37 = dSfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
            t46 = dSfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
            t58 = dSfnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta,irr)
            t65 = dSfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
            t70 = t1*t2*t4*t65*u(i,n-1)*t10
     &           +t14*t2*sigma*q(i,n1-1)+t14*t2*theta*q(i,n1)
     &           +t25sig*t26*u(zt28,zt29)+t25thet*t26*u(zt28,n)
     &           +t25sig*t37*u(i,zt29)+t25thet*t37*u(i,n)
     &           +t25sig*t46*u(zt50,zt29)+t25thet*t46*u(zt50,n)
     &           +t25sig*t58*u(zt60,zt29)+t25thet*t58*u(zt60,n)
     &           +gdS(irr)*t10
            gdS(irr) = t70/t10
         enddo
      enddo
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         t1 = vvzz(i)
         t4 = falphaa(i,3)
         t11 = falphak(i)
         t13 = fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
         zt15 = i+nx
         zt16 = n-2
         t17 = u(zt15,zt16)
         zt23 = nx*(ny+1)
         zt24 = zt23+i
         t25 = u(zt24,n)
         t28 = fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
         t33 = u(zt24,zt16)
         t37 = u(zt15,n)
         t40 = fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
         t42 = u(i,n)
         t45 = t1*t4
         t46 = fT(ndT,T,i)
         t50 = u(i,n-1)
         t55 = u(i,zt16)
         t64 = t1*t46*t11
         zt67 = zt23+i+1
         t68 = u(zt67,n)
         t78 = u(zt67,zt16)
         t108 = fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)
         do   irr   =   1   ,   ndT   ,   1
            t3 = t1*dTfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
            t9 = dfT(ndT,T,i,irr)
            t10 = t1*t9
            t12 = t10*t11
            t65 = dTfnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta,irr)
            t76 = 
     &           t3*t4*sigma*q(i,n1-1)+t3*t4*theta*q(i,n1)
     &           +t12*t13*sigma*t17+t12*t13*theta*t37
     &           -t10*t11*fAinv(i,3,1)*t25
     &           +t12*t28*theta*t25+t12*t28*sigma*t33
     &           +t12*t40*theta*t42+t12*t40*sigma*t55
     &           +t45*t46*dTfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &           *t50*t11
     &           +t45*t9*fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*t50*t11
     &           +t64*t65*theta*t68
            t81 = dTfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
            t85 = dTfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
            t92 = dTfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
            t123 = 
     &           t64*t65*sigma*t78+t64*t81*theta*t25
     &           +t64*t85*theta*t42+t64*t81*sigma*t33
     &           +t64*t92*theta*t37
     &           +gdT(irr)*t11
     &           -t10*t11*fAinv(i,3,2)*t68
     &           +t64*t85*sigma*t55
     &           +t64*t92*sigma*t17
     &           +t12*t108*theta*t68
     &           -t10*t11*fAinv(i,3,4)*t37
     &           +t12*t108*sigma*t78
     &           -t10*t11*fAinv(i,3,3)*t42
            gdT(irr) = (t76+t123)/t11
         enddo
      enddo
c     .....................
      i = j*nx
      t1 = vvzz(i)
      t2 = falphaa(i,3)
      t4 = fT(ndT,T,i)
      t10 = falphak(i)
      t25 = t1*t4*t10
      zt28 = i+nx
      zt29 = n-2
      zt50 = nx*(ny+1)+i
      do   irr   =   1   ,   ndS   ,   1
         t14 = t1*dSfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
         t26 = dSfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
         t37 = dSfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
         t46 = dSfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
         gdS(irr) = (
     &        t1*t2*t4*dSfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &        *u(i,n-1)*t10
     &        +t14*t2*sigma*q(i,n1-1)
     &        +t14*t2*theta*q(i,n1)
     &        +t25*t26*sigma*u(zt28,zt29)
     &        +t25*t26*theta*u(zt28,n)
     &        +t25*t37*sigma*u(i,zt29)
     &        +t25*t37*theta*u(i,n)
     &        +t25*t46*sigma*u(zt50,zt29)
     &        +t25*t46*theta*u(zt50,n)
     &        +gdS(irr)*t10)/t10
      enddo
      i = j*nx
      t1 = vvzz(i)
      t2 = falphaa(i,3)
      t3 = t1*t2
      t8 = u(i,n-1)
      t10 = falphak(i)
      t13 = fT(ndT,T,i)
      t32 = fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
      zt34 = i+nx
      zt35 = n-2
      t36 = u(zt34,zt35)
      t40 = u(zt34,n)
      t43 = fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
      t45 = u(i,zt35)
      t49 = u(i,n)
      t52 = fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
      zt56 = nx*(ny+1)+i
      t57 = u(zt56,zt35)
      t61 = u(zt56,n)
      t77 = t1*t13*t10
      do   irr   =   1   ,   ndT   ,   1
         t4 = dfT(ndT,T,i,irr)
         t20 = t1*dTfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
         t30 = t1*t4
         t31 = t30*t10
         t78 = dTfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
         t85 = dTfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
         t92 = dTfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
         t101 = 
     &        t3*t4*fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)*t8*t10
     &        +t3*t13*dTfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)*t8*t10
     &        +t20*t2*sigma*q(i,n1-1)
     &        +t20*t2*theta*q(i,n1)
     &        +t31*t32*sigma*t36
     &        +t31*t32*theta*t40
     &        +t31*t43*sigma*t45
     &        +t31*t43*theta*t49
     &        +t31*t52*sigma*t57
     &        +t31*t52*theta*t61
     &        -t30*t10*fAinv(i,3,4)*t40
     &        -t30*t10*fAinv(i,3,3)*t49
     &        -t30*t10*fAinv(i,3,1)*t61
     &        +t77*t78*sigma*t36
     &        +t77*t78*theta*t40
     &        +t77*t85*sigma*t45
     &        +t77*t85*theta*t49
     &        +t77*t92*sigma*t57
     &        +t77*t92*theta*t61
     &        +gdT(irr)*t10
         gdT(irr) = t101/t10
      enddo
c     .....................
      i = nx*(ny+1)+(j-1)*nx+1
c     .....................
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         t1 = vvzz(i)
         zt2 = nx*ny
         zt3 = i-zt2-nx-1
         t4 = falphaa(zt3,2)
         t6 = fT(ndT,T,zt3)
         zt10 = nx*(ny+1)
         zt11 = i-zt10-1
         zt12 = n-1
         t15 = falphak(zt3)
         zt16 = i-zt2-nx
         t17 = falphak(zt16)
         t18 = t15*t17
         t21 = falphaa(zt16,1)
         t23 = fT(ndT,T,zt16)
         zt26 = i-zt10
         zt35 = n1-1
         t55 = t1*t6*t15
         zt58 = i-zt2-1
         zt59 = n-2
         zt80 = i-1
         t93 = sigma*u(i,zt59)
         t97 = theta*u(i,n)
         t101 = t1*t23*t15
         zt104 = i-zt2
         zt131 = i+1
         do   irr   =   1   ,   ndS   ,   1
            t33 = t1*dSfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t4
            t45 = t1*dSfbeta(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)*t21
            t57 = t17*dSfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
            t69 = t17*dSfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
            t79 = t17*dSfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
            t85 = 
     &           t1*t4*t6*dSfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &           *u(zt11,zt12)*t18
     &           +t1*t21*t23
     &           *dSfgamma(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)
     &           *u(zt26,zt12)*t18
     &           +t33*t17*sigma*q(zt11,zt35)
     &           +t33*t17*theta*q(zt11,n1)
     &           +t45*t15*sigma*q(zt26,zt35)
     &           +t45*t15*theta*q(zt26,n1)
     &           +t55*t57*sigma*u(zt58,zt59)
     &           +t55*t57*theta*u(zt58,n)
     &           +t55*t69*sigma*u(zt11,zt59)
     &           +t55*t69*theta*u(zt11,n)
     &           +t55*t79*sigma*u(zt80,zt59)
            t91 = t17*dSfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
            t103 = t17*dSfnu(ndS,S,ndT,T,zt16,1,4,dt,dx,dy,theta,irr)
            t114 = t17*dSfnu(ndS,S,ndT,T,zt16,1,3,dt,dx,dy,theta,irr)
            t124 = t17*dSfnu(ndS,S,ndT,T,zt16,1,1,dt,dx,dy,theta,irr)
            t130 = t17*dSfnu(ndS,S,ndT,T,zt16,1,2,dt,dx,dy,theta,irr)
            t143 = 
     &           t55*t79*theta*u(zt80,n)
     &           +t55*t91*t93
     &           +t55*t91*t97
     &           +t101*t103*sigma*u(zt104,zt59)
     &           +t101*t103*theta*u(zt104,n)
     &           +t101*t114*sigma*u(zt26,zt59)
     &           +t101*t114*theta*u(zt26,n)
     &           +t101*t124*t93+t101*t124*t97
     &           +t101*t130*sigma*u(zt131,zt59)
     &           +t101*t130*theta*u(zt131,n)
     &           +gdS(irr)*t15*t17
            gdS(irr) = (t85+t143)/t15/t17
         enddo
      enddo
      do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1   ,   1
         t1 = vvzz(i)
         zt2 = nx*ny
         zt3 = i-zt2-nx
         zt6 = i-zt2-nx-1
         t7 = falphak(zt6)
         t9 = falphak(zt3)
         t11 = t9*fnu(ndS,S,ndT,T,zt3,1,2,dt,dx,dy,theta)
         zt12 = i+1
         t13 = u(zt12,n)
         t14 = theta*t13
         t17 = fT(ndT,T,zt3)
         t19 = t1*t17*t7
         zt22 = n-2
         t24 = sigma*u(i,zt22)
         zt34 = nx*(ny+1)
         zt35 = i-zt34
         t36 = u(zt35,n)
         zt41 = i-zt2
         t42 = u(zt41,n)
         t45 = u(i,n)
         t46 = theta*t45
         t50 = t9*fnu(ndS,S,ndT,T,zt3,1,4,dt,dx,dy,theta)
         t51 = theta*t42
         t55 = t9*fnu(ndS,S,ndT,T,zt3,1,3,dt,dx,dy,theta)
         t56 = theta*t36
         t59 = falphaa(zt3,1)
         t60 = t1*t59
         zt63 = n-1
         t64 = u(zt35,zt63)
         t66 = t7*t9
         t70 = sigma*u(zt41,zt22)
         t73 = fT(ndT,T,zt6)
         t75 = t1*t73*t7
         zt78 = i-1
         t79 = u(zt78,n)
         t80 = theta*t79
         t89 = sigma*u(zt12,zt22)
         t93 = t9*fnu(ndS,S,ndT,T,zt3,1,1,dt,dx,dy,theta)
         t100 = sigma*u(zt35,zt22)
         t115 = falphaa(zt6,2)
         zt118 = i-zt34-1
         zt119 = n1-1
         zt125 = i-zt2-1
         t126 = u(zt125,n)
         t127 = theta*t126
         t141 = u(zt118,n)
         t147 = t9*fnu(ndS,S,ndT,T,zt6,2,2,dt,dx,dy,theta)
         t153 = t9*fnu(ndS,S,ndT,T,zt6,2,1,dt,dx,dy,theta)
         t161 = sigma*u(zt125,zt22)
         t167 = sigma*u(zt118,zt22)
         t173 = t9*fnu(ndS,S,ndT,T,zt6,2,4,dt,dx,dy,theta)
         t177 = sigma*u(zt78,zt22)
         t180 = theta*t141
         t184 = t9*fnu(ndS,S,ndT,T,zt6,2,3,dt,dx,dy,theta)
         t192 = t1*t115
         t195 = u(zt118,zt63)
         do   irr   =   1   ,   ndT   ,   1
            t4 = dfT(ndT,T,zt3,irr)
            t8 = t1*t4*t7
            t21 = t9*dTfnu(ndS,S,ndT,T,zt3,1,1,dt,dx,dy,theta,irr)
            t28 = t9*dTfnu(ndS,S,ndT,T,zt3,1,2,dt,dx,dy,theta,irr)
            t77 = t9*dTfnu(ndS,S,ndT,T,zt6,2,1,dt,dx,dy,theta,irr)
            t84 = t9*dTfnu(ndS,S,ndT,T,zt3,1,4,dt,dx,dy,theta,irr)
            t87 = 
     &           t8*t11*t14
     &           +t19*t21*t24
     &           +t19*t28*t14
     &           -t8*t9*fAinv(zt3,1,3)*t36
     &           -t8*t9*fAinv(zt3,1,4)*t42
     &           +t19*t21*t46
     &           +t8*t50*t51
     &           +t8*t55*t56
     &           +t60*t4*fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*t64*t66
     &           +t8*t50*t70
     &           +t75*t77*t80
     &           +t19*t84*t51
            t104 = t9*dTfnu(ndS,S,ndT,T,zt3,1,3,dt,dx,dy,theta,irr)
            t108 = t9*dTfnu(ndS,S,ndT,T,zt6,2,2,dt,dx,dy,theta,irr)
            t116 = t1*dTfbeta(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)*t115
            t124 = t9*dTfnu(ndS,S,ndT,T,zt6,2,4,dt,dx,dy,theta,irr)
            t132 = dfT(ndT,T,zt6,irr)
            t134 = t1*t132*t7
            t144 = 
     &           t19*t28*t89
     &           +t8*t93*t46
     &           +gdT(irr)*t7*t9
     &           +t8*t55*t100
     &           +t19*t104*t56
     &           +t75*t108*t46
     &           +t75*t108*t24
     &           +t116*t9*sigma*q(zt118,zt119)
     &           +t75*t124*t127
     &           +t8*t11*t89
     &           -t134*t9*fAinv(zt6,2,1)*t79
     &           -t134*t9*fAinv(zt6,2,3)*t141
            t165 = t9*dTfnu(ndS,S,ndT,T,zt6,2,3,dt,dx,dy,theta,irr)
            t191 = 
     &           t134*t147*t46
     &           +t134*t147*t24
     &           +t134*t153*t80
     &           -t134*t9*fAinv(zt6,2,2)*t45
     &           +t75*t124*t161
     &           +t75*t165*t167
     &           +t8*t93*t24
     &           +t134*t173*t127
     &           +t75*t77*t177
     &           +t75*t165*t180
     &           +t134*t184*t167
     &           +t116*t9*theta*q(zt118,n1)
            t207 = t1*dTfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t59
            t242 = 
     &           t192*t132*fgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta)
     &           *t195*t66
     &           +t134*t173*t161
     &           -t134*t9*fAinv(zt6,2,4)*t126
     &           +t207*t7*theta*q(zt35,n1)
     &           +t134*t184*t180
     &           +t19*t104*t100
     &           +t60*t17*dTfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &           *t64*t66
     &           -t8*t9*fAinv(zt3,1,1)*t45
     &           +t134*t153*t177
     &           +t19*t84*t70
     &           +t207*t7*sigma*q(zt35,zt119)
     &           -t8*t9*fAinv(zt3,1,2)*t13
     &           +t192*t73*dTfgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)
     &           *t195*t66
            gdT(irr) = (t87+t144+t191+t242)/t7/t9
         enddo
      enddo
c     .....................
      i = nx*(ny+1)+j*nx
      t1 = vvzz(i)
      zt2 = nx*ny
      zt3 = i-zt2-nx-1
      t4 = falphaa(zt3,2)
      t6 = fT(ndT,T,zt3)
      zt10 = nx*(ny+1)
      zt11 = i-zt10-1
      zt12 = n-1
      t15 = falphak(zt3)
      zt16 = i-zt2-nx
      t17 = falphak(zt16)
      t18 = t15*t17
      t21 = falphaa(zt16,1)
      t23 = fT(ndT,T,zt16)
      zt26 = i-zt10
      zt35 = n1-1
      t55 = t1*t6*t15
      zt58 = i-zt2-1
      zt59 = n-2
      zt81 = i-1
      t93 = sigma*u(i,zt59)
      t97 = theta*u(i,n)
      t101 = t1*t23*t15
      zt104 = i-zt2
      do   irr   =   1   ,   ndS   ,   1
         t33 = t1*dSfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t4
         t45 = t1*dSfbeta(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)*t21
         t57 = t17*dSfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
         t69 = t17*dSfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
         t80 = t17*dSfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
         t91 = t17*dSfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
         t103 = t17*dSfnu(ndS,S,ndT,T,zt16,1,4,dt,dx,dy,theta,irr)
         t114 = t17*dSfnu(ndS,S,ndT,T,zt16,1,3,dt,dx,dy,theta,irr)
         t124 = t17*dSfnu(ndS,S,ndT,T,zt16,1,1,dt,dx,dy,theta,irr)
         t132 = 
     &        t55*t80*sigma*u(zt81,zt59)
     &        +t55*t80*theta*u(zt81,n)
     &        +t55*t91*t93
     &        +t55*t91*t97
     &        +t101*t103*sigma*u(zt104,zt59)
     &        +t101*t103*theta*u(zt104,n)
     &        +t101*t114*sigma*u(zt26,zt59)
     &        +t101*t114*theta*u(zt26,n)
     &        +t101*t124*t93
     &        +t101*t124*t97
     &        +gdS(irr)*t15*t17
         gdS(irr) = (
     &        t1*t4*t6*dSfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &        *u(zt11,zt12)*t18
     &        +t1*t21*t23*dSfgamma(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)
     &        *u(zt26,zt12)*t18
     &        +t33*t17*sigma*q(zt11,zt35)
     &        +t33*t17*theta*q(zt11,n1)
     &        +t45*t15*sigma*q(zt26,zt35)
     &        +t45*t15*theta*q(zt26,n1)
     &        +t55*t57*sigma*u(zt58,zt59)
     &        +t55*t57*theta*u(zt58,n)
     &        +t55*t69*sigma*u(zt11,zt59)
     &        +t55*t69*theta*u(zt11,n)
     &        +t132
     &        )/t15/t17
      enddo
      i = nx*(ny+1)+j*nx
      zt2 = nx*ny
      zt3 = i-zt2-nx-1
      t4 = falphak(zt3)
      zt6 = i-zt2-nx
      t7 = falphak(zt6)
      t9 = vvzz(i)
      t10 = falphaa(zt3,2)
      t11 = t9*t10
      zt16 = nx*(ny+1)
      zt17 = i-zt16-1
      zt18 = n-1
      t19 = u(zt17,zt18)
      t21 = t4*t7
      t26 = falphaa(zt6,1)
      zt29 = i-zt16
      t38 = u(i,n)
      t41 = t9*t26
      t42 = fT(ndT,T,zt6)
      t45 = u(zt29,zt18)
      t49 = fT(ndT,T,zt3)
      t51 = t9*t49*t4
      t54 = theta*t38
      t58 = t7*fnu(ndS,S,ndT,T,zt6,1,4,dt,dx,dy,theta)
      zt59 = i-zt2
      zt60 = n-2
      t62 = sigma*u(zt59,zt60)
      t65 = u(zt59,n)
      t66 = theta*t65
      t70 = t7*fnu(ndS,S,ndT,T,zt6,1,3,dt,dx,dy,theta)
      t72 = sigma*u(zt29,zt60)
      t75 = u(zt29,n)
      t76 = theta*t75
      t80 = t7*fnu(ndS,S,ndT,T,zt6,1,1,dt,dx,dy,theta)
      t82 = sigma*u(i,zt60)
      t89 = t9*t42*t4
      t97 = t7*fnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta)
      zt98 = i-zt2-1
      t99 = u(zt98,n)
      t100 = theta*t99
      t104 = t7*fnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta)
      zt105 = i-1
      t107 = sigma*u(zt105,zt60)
      t115 = t7*fnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta)
      t116 = u(zt17,n)
      t117 = theta*t116
      t125 = t7*fnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta)
      t133 = sigma*u(zt17,zt60)
      t145 = sigma*u(zt98,zt60)
      t160 = u(zt105,n)
      t161 = theta*t160
      zt179 = n1-1
      do   irr   =   1   ,   ndT   ,   1
         t12 = dfT(ndT,T,zt3,irr)
         t27 = t9*dTfbeta(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)*t26
         t33 = dfT(ndT,T,zt6,irr)
         t35 = t9*t33*t4
         t53 = t7*dTfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
         t85 = 
     &        gdT(irr)*t4*t7
     &        +t11*t12*fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*t19*t21
     &        +t27*t4*theta*q(zt29,n1)
     &        -t35*t7*fAinv(zt6,1,1)*t38
     &        +t41*t42*dTfgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)
     &        *t45*t21
     &        +t51*t53*t54
     &        +t35*t58*t62
     &        +t35*t58*t66
     &        +t35*t70*t72
     &        +t35*t70*t76
     &        +t35*t80*t82
         t91 = t7*dTfnu(ndS,S,ndT,T,zt6,1,4,dt,dx,dy,theta,irr)
         t95 = t9*t12*t4
         t140 = 
     &        t35*t80*t54
     &        +t89*t91*t66
     &        +t95*t97*t100
     &        +t95*t104*t107
     &        -t95*t7*fAinv(zt3,2,4)*t99
     &        +t95*t115*t117
     &        -t35*t7*fAinv(zt6,1,4)*t65
     &        +t95*t125*t82
     &        -t35*t7*fAinv(zt6,1,3)*t75
     &        +t95*t115*t133
     &        -t95*t7*fAinv(zt3,2,2)*t38
         t143 = t7*dTfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
         t151 = t7*dTfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
         t155 = t7*dTfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
         t177 = t9*dTfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t10
         t185 = 
     &        t51*t143*t145
     &        +t51*t143*t100
     &        +t51*t151*t117
     &        +t51*t155*t107
     &        +t51*t151*t133
     &        +t51*t155*t161
     &        +t51*t53*t82
     &        -t95*t7*fAinv(zt3,2,1)*t160
     &        +t41*t33*fgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta)*t45*t21
     &        +t177*t7*sigma*q(zt17,zt179)
     &        +t95*t104*t161
         t194 = t7*dTfnu(ndS,S,ndT,T,zt6,1,3,dt,dx,dy,theta,irr)
         t198 = t7*dTfnu(ndS,S,ndT,T,zt6,1,1,dt,dx,dy,theta,irr)
         t221 = 
     &        t11*t49*dTfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &        *t19*t21
     &        +t95*t125*t54
     &        +t89*t194*t76
     &        +t89*t198*t82
     &        +t89*t91*t62
     &        +t89*t194*t72
     &        +t89*t198*t54
     &        +t27*t4*sigma*q(zt29,zt179)
     &        +t177*t7*theta*q(zt17,n1)
     &        +t95*t97*t145
     &        -t95*t7*fAinv(zt3,2,3)*t116
         gdT(irr) = (t85+t140+t185+t221)/t4/t7
      enddo
c     ---------------------------------------------------------------
      do   j   =   2   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            t1 = vvzz(i)
            zt2 = i-nx
            t3 = falphaa(zt2,4)
            t5 = fT(ndT,T,zt2)
            zt8 = n-1
            t11 = falphak(zt2)
            t12 = falphak(i)
            t13 = t11*t12
            t16 = falphaa(i,3)
            t18 = fT(ndT,T,i)
            zt29 = n1-1
            t49 = t1*t5*t11
            zt52 = n-2
            t54 = sigma*u(i,zt52)
            t58 = theta*u(i,n)
            zt73 = nx*ny
            zt74 = zt73+i
            zt86 = zt73+i+1
            t96 = t1*t18*t11
            zt99 = i+nx
            zt117 = nx*(ny+1)
            zt118 = zt117+i
            zt129 = zt117+i+1
            do   irr   =   1   ,   ndS   ,   1
               t27 = t1*dSfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t3
               t39 = t1*dSfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)*t16
               t51 = t12*dSfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
               t62 = t12*dSfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
               t72 = t12*dSfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
               t79 = 
     &              t1*t3*t5
     &              *dSfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &              *u(zt2,zt8)*t13
     &              +t1*t16*t18
     &              *dSfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &              *u(i,zt8)*t13
     &              +t27*t12*sigma*q(zt2,zt29)
     &              +t27*t12*theta*q(zt2,n1)
     &              +t39*t11*sigma*q(i,zt29)
     &              +t39*t11*theta*q(i,n1)
     &              +t49*t51*t54+t49*t51*t58
     &              +t49*t62*sigma*u(zt2,zt52)
     &              +t49*t62*theta*u(zt2,n)
     &              +t49*t72*sigma*u(zt74,zt52)
               t85 = t12*dSfnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta,irr)
               t98 = t12*dSfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
               t109 = t12*dSfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
               t115 = t12*dSfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
               t128 = t12*dSfnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta,irr)
               t141 = 
     &              t49*t72*theta*u(zt74,n)
     &              +t49*t85*sigma*u(zt86,zt52)
     &              +t49*t85*theta*u(zt86,n)
     &              +t96*t98*sigma*u(zt99,zt52)
     &              +t96*t98*theta*u(zt99,n)
     &              +t96*t109*t54
     &              +t96*t109*t58
     &              +t96*t115*sigma*u(zt118,zt52)
     &              +t96*t115*theta*u(zt118,n)
     &              +t96*t128*sigma*u(zt129,zt52)
     &              +t96*t128*theta*u(zt129,n)
     &              +gdS(irr)*t11*t12
               gdS(irr) = (t79+t141)/t11/t12
            enddo
         enddo
         do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
            t1 = vvzz(i)
            zt2 = i-nx
            t5 = falphak(zt2)
            t7 = falphak(i)
            t9 = t7*fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)
            zt10 = n-2
            t12 = sigma*u(zt2,zt10)
            t15 = falphaa(i,3)
            t16 = t1*t15
            t17 = fT(ndT,T,i)
            zt20 = n-1
            t21 = u(i,zt20)
            t23 = t5*t7
            t28 = falphaa(zt2,4)
            t35 = t1*t17*t5
            zt39 = nx*(ny+1)
            zt40 = zt39+i
            t41 = u(zt40,n)
            t42 = theta*t41
            t45 = fT(ndT,T,zt2)
            t47 = t1*t45*t5
            zt50 = nx*ny
            zt51 = zt50+i
            t53 = sigma*u(zt51,zt10)
            t58 = u(zt2,n)
            t59 = theta*t58
            t69 = u(i,n)
            t70 = theta*t69
            t74 = t7*fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)
            t76 = sigma*u(i,zt10)
            t79 = t1*t28
            t82 = u(zt2,zt20)
            zt90 = n1-1
            t99 = t7*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
            zt104 = zt50+i+1
            t105 = u(zt104,n)
            t110 = u(zt51,n)
            t122 = sigma*u(zt40,zt10)
            t133 = theta*t110
            t137 = t7*fnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta)
            zt138 = zt39+i+1
            t139 = u(zt138,n)
            t140 = theta*t139
            t144 = sigma*u(zt138,zt10)
            t150 = t7*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
            zt151 = i+nx
            t153 = sigma*u(zt151,zt10)
            t178 = t7*fnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta)
            t180 = sigma*u(zt104,zt10)
            t183 = theta*t105
            t187 = t7*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
            t190 = u(zt151,n)
            t191 = theta*t190
            t222 = t7*fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)
            do   irr   =   1   ,   ndT   ,   1
               t3 = dfT(ndT,T,zt2,irr)
               t6 = t1*t3*t5
               t29 = t1*dTfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t28
               t37 = t7*dTfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
               t49 = t7*dTfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
               t57 = t7*dTfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
               t68 = t7*dTfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
               t88 = t1*dTfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)*t15
               t94 = 
     &              -t6*t9*t12
     &              -t16*t17*dTfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &              *t21*t23
     &              -t29*t7*theta*q(zt2,n1)
     &              -t35*t37*t42
     &              -t47*t49*t53
     &              -t47*t57*t59
     &              -t47*t57*t12
     &              -gdT(irr)*t5*t7
     &              -t47*t68*t70
     &              -t6*t74*t76
     &              -t79*t3*fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)
     &              *t82*t23
     &              -t88*t5*sigma*q(i,zt90)
               t95 = dfT(ndT,T,i,irr)
               t97 = t1*t95*t5
               t130 = t7*dTfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
               t147 = 
     &              -t97*t99*t42
     &              +t6*t7*fAinv(zt2,4,2)*t105
     &              +t6*t7*fAinv(zt2,4,1)*t110
     &              -t6*t74*t70
     &              +t6*t7*fAinv(zt2,4,3)*t58
     &              -t47*t68*t76
     &              -t35*t37*t122
     &              +t6*t7*fAinv(zt2,4,4)*t69
     &              -t35*t130*t70
     &              -t47*t49*t133
     &              -t97*t137*t140
     &              -t97*t137*t144
               t163 = t7*dTfnu(ndS,S,ndT,T,i,3,2,dt,dx,dy,theta,irr)
               t196 = 
     &              -t97*t150*t153
     &              -t35*t130*t76
     &              +t97*t7*fAinv(i,3,2)*t139
     &              -t35*t163*t140
     &              -t16*t95*fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)
     &              *t21*t23
     &              -t6*t9*t59
     &              -t29*t7*sigma*q(zt2,zt90)
     &              -t6*t178*t180
     &              -t6*t178*t183
     &              -t97*t187*t76
     &              -t97*t150*t191
     &              -t35*t163*t144
               t206 = t7*dTfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
               t212 = t7*dTfnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta,irr)
               t240 = 
     &              t97*t7*fAinv(i,3,3)*t69
     &              -t88*t5*theta*q(i,n1)
     &              -t35*t206*t153
     &              -t97*t187*t70
     &              -t47*t212*t180
     &              -t35*t206*t191
     &              +t97*t7*fAinv(i,3,1)*t41
     &              -t6*t222*t133
     &              -t6*t222*t53
     &              -t79*t45
     &              *dTfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &              *t82*t23
     &              -t97*t99*t122
     &              +t97*t7*fAinv(i,3,4)*t190
     &              -t47*t212*t183
               gdT(irr) = -(t94+t147+t196+t240)/t5/t7
            enddo
         enddo
c     .....................
         i = j*nx
         t1 = vvzz(i)
         zt2 = i-nx
         t3 = falphaa(zt2,4)
         t5 = fT(ndT,T,zt2)
         zt8 = n-1
         t11 = falphak(zt2)
         t12 = falphak(i)
         t13 = t11*t12
         t16 = falphaa(i,3)
         t18 = fT(ndT,T,i)
         zt29 = n1-1
         t49 = t1*t5*t11
         zt52 = n-2
         t54 = sigma*u(i,zt52)
         t58 = theta*u(i,n)
         zt74 = nx*ny+i
         t84 = t1*t18*t11
         zt87 = i+nx
         zt106 = nx*(ny+1)+i
         do   irr   =   1   ,   ndS   ,   1
            t27 = t1*dSfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t3
            t39 = t1*dSfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)*t16
            t51 = t12*dSfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
            t62 = t12*dSfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
            t72 = t12*dSfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
            t86 = t12*dSfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
            t97 = t12*dSfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
            t103 = t12*dSfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
            t118 = 
     &           t1*t3*t5*dSfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &           *u(zt2,zt8)*t13
     &           +t1*t16*t18*dSfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &           *u(i,zt8)*t13
     &           +t27*t12*sigma*q(zt2,zt29)
     &           +t27*t12*theta*q(zt2,n1)
     &           +t39*t11*sigma*q(i,zt29)
     &           +t39*t11*theta*q(i,n1)
     &           +t49*t51*t54
     &           +t49*t51*t58
     &           +t49*t62*sigma*u(zt2,zt52)
     &           +t49*t62*theta*u(zt2,n)
     &           +t49*t72*sigma*u(zt74,zt52)
     &           +t49*t72*theta*u(zt74,n)
     &           +t84*t86*sigma*u(zt87,zt52)
     &           +t84*t86*theta*u(zt87,n)
     &           +t84*t97*t54
     &           +t84*t97*t58
     &           +t84*t103*sigma*u(zt106,zt52)
     &           +t84*t103*theta*u(zt106,n)
     &           +gdS(irr)*t11*t12
            gdS(irr) = t118/t11/t12
         enddo
         i = j*nx
         t1 = vvzz(i)
         zt2 = i-nx
         t3 = fT(ndT,T,zt2)
         t5 = falphak(zt2)
         t6 = t1*t3*t5
         t7 = falphak(i)
         zt10 = n-2
         t12 = sigma*u(i,zt10)
         t17 = falphaa(i,3)
         zt20 = n1-1
         t24 = fT(ndT,T,i)
         t26 = t1*t24*t5
         zt29 = i+nx
         t31 = sigma*u(zt29,zt10)
         zt41 = nx*(ny+1)+i
         t42 = u(zt41,n)
         t46 = t7*fnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta)
         t47 = u(i,n)
         t48 = theta*t47
         t51 = u(zt29,n)
         t52 = theta*t51
         t62 = t7*fnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta)
         t70 = t7*fnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta)
         t71 = theta*t42
         t76 = falphaa(zt2,4)
         zt89 = nx*ny+i
         t90 = u(zt89,n)
         t91 = theta*t90
         t95 = sigma*u(zt89,zt10)
         t100 = u(zt2,n)
         t101 = theta*t100
         t109 = sigma*u(zt2,zt10)
         t119 = t7*fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)
         t125 = t7*fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)
         t133 = sigma*u(zt41,zt10)
         t150 = t1*t17
         zt153 = n-1
         t154 = u(i,zt153)
         t156 = t5*t7
         t164 = t7*fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)
         t174 = t1*t76
         t177 = u(zt2,zt153)
         do   irr   =   1   ,   ndT   ,   1
            t9 = t7*dTfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
            t18 = t1*dTfbeta(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)*t17
            t28 = t7*dTfnu(ndS,S,ndT,T,i,3,4,dt,dx,dy,theta,irr)
            t34 = dfT(ndT,T,i,irr)
            t36 = t1*t34*t5
            t77 = t1*dTfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t76
            t87 = t7*dTfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
            t99 = t7*dTfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
            t105 = t7*dTfnu(ndS,S,ndT,T,i,3,1,dt,dx,dy,theta,irr)
            t114 = 
     &           t6*t9*t12
     &           +t18*t5*sigma*q(i,zt20)
     &           +t26*t28*t31
     &           -t36*t7*fAinv(i,3,1)*t42
     &           +t36*t46*t48
     &           +t26*t28*t52
     &           -t36*t7*fAinv(i,3,3)*t47
     &           +t36*t46*t12
     &           +t36*t62*t52
     &           -t36*t7*fAinv(i,3,4)*t51
     &           +t36*t70*t71
     &           +t77*t7*theta*q(zt2,n1)
     &           +t77*t7*sigma*q(zt2,zt20)
     &           +t6*t87*t91
     &           +t6*t87*t95
     &           +t6*t99*t101
     &           +t26*t105*t71
     &           +t6*t99*t109
     &           +t6*t9*t48
            t115 = dfT(ndT,T,zt2,irr)
            t117 = t1*t115*t5
            t141 = t7*dTfnu(ndS,S,ndT,T,i,3,3,dt,dx,dy,theta,irr)
            t195 = 
     &           t117*t119*t48
     &           +t117*t119*t12
     &           +t117*t125*t91
     &           -t117*t7*fAinv(zt2,4,3)*t100
     &           +t26*t105*t133
     &           +t36*t70*t133
     &           +t117*t125*t95
     &           +t26*t141*t48
     &           -t117*t7*fAinv(zt2,4,4)*t47
     &           +t26*t141*t12
     &           +t150*t34*fgamma(ndS,S,ndT,T,i,dt,dx,dy,theta)
     &           *t154*t156
     &           +t18*t5*theta*q(i,n1)
     &           +t117*t164*t109
     &           +t150*t24*dTfgamma(ndS,S,ndT,T,i,dt,dx,dy,theta,irr)
     &           *t154*t156
     &           +t117*t164*t101
     &           +t174*t3*dTfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &           *t177*t156
     &           +gdT(irr)*t5*t7
     &           -t117*t7*fAinv(zt2,4,1)*t90
     &           +t174*t115*fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)
     &           *t177*t156
     &           +t36*t62*t31
            gdT(irr) = (t114+t195)/t5/t7
         enddo
c     .....................
         i = nx*(ny+1)+(j-1)*nx+1
c     .....................
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            t1 = vvzz(i)
            zt2 = nx*ny
            zt3 = i-zt2-nx-1
            t4 = falphaa(zt3,2)
            t6 = fT(ndT,T,zt3)
            zt10 = nx*(ny+1)
            zt11 = i-zt10-1
            zt12 = n-1
            t15 = falphak(zt3)
            zt16 = i-zt2-nx
            t17 = falphak(zt16)
            t18 = t15*t17
            t21 = falphaa(zt16,1)
            t23 = fT(ndT,T,zt16)
            zt26 = i-zt10
            zt35 = n1-1
            t55 = t1*t6*t15
            zt58 = i-zt2-1
            zt59 = n-2
            zt80 = i-1
            t93 = sigma*u(i,zt59)
            t97 = theta*u(i,n)
            t101 = t1*t23*t15
            zt104 = i-zt2
            zt131 = i+1
            do   irr   =   1   ,   ndS   ,   1
               t33 = t1*dSfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t4
               t45 = t1*dSfbeta(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)*t21
               t57 = t17*dSfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
               t69 = t17*dSfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
               t79 = t17*dSfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
               t85 = 
     &              t1*t4*t6
     &              *dSfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &              *u(zt11,zt12)*t18
     &              +t1*t21*t23
     &              *dSfgamma(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)
     &              *u(zt26,zt12)*t18
     &              +t33*t17*sigma*q(zt11,zt35)
     &              +t33*t17*theta*q(zt11,n1)
     &              +t45*t15*sigma*q(zt26,zt35)
     &              +t45*t15*theta*q(zt26,n1)
     &              +t55*t57*sigma*u(zt58,zt59)
     &              +t55*t57*theta*u(zt58,n)
     &              +t55*t69*sigma*u(zt11,zt59)
     &              +t55*t69*theta*u(zt11,n)
     &              +t55*t79*sigma*u(zt80,zt59)
               t91 = t17*dSfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
               t103 = t17*dSfnu(ndS,S,ndT,T,zt16,1,4,dt,dx,dy,theta,irr)
               t114 = t17*dSfnu(ndS,S,ndT,T,zt16,1,3,dt,dx,dy,theta,irr)
               t124 = t17*dSfnu(ndS,S,ndT,T,zt16,1,1,dt,dx,dy,theta,irr)
               t130 = t17*dSfnu(ndS,S,ndT,T,zt16,1,2,dt,dx,dy,theta,irr)
               t143 = 
     &              t55*t79*theta*u(zt80,n)
     &              +t55*t91*t93
     &              +t55*t91*t97
     &              +t101*t103*sigma*u(zt104,zt59)
     &              +t101*t103*theta*u(zt104,n)
     &              +t101*t114*sigma*u(zt26,zt59)
     &              +t101*t114*theta*u(zt26,n)
     &              +t101*t124*t93
     &              +t101*t124*t97
     &              +t101*t130*sigma*u(zt131,zt59)
     &              +t101*t130*theta*u(zt131,n)
     &              +gdS(irr)*t15*t17
               gdS(irr) = (t85+t143)/t15/t17
            enddo
         enddo
         do   i   =   nx*(ny+1)+(j-1)*nx+2   ,   nx*(ny+1)+j*nx-1
            t1 = vvzz(i)
            zt2 = nx*ny
            zt3 = i-zt2-nx
            t4 = fT(ndT,T,zt3)
            zt6 = i-zt2-nx-1
            t7 = falphak(zt6)
            t8 = t1*t4*t7
            t9 = falphak(zt3)
            zt12 = n-2
            t14 = sigma*u(i,zt12)
            zt20 = nx*(ny+1)
            zt21 = i-zt20
            t23 = sigma*u(zt21,zt12)
            t30 = t9*fnu(ndS,S,ndT,T,zt3,1,2,dt,dx,dy,theta)
            zt31 = i+1
            t32 = u(zt31,n)
            t33 = theta*t32
            t36 = fT(ndT,T,zt6)
            t38 = t1*t36*t7
            zt41 = i-1
            t43 = sigma*u(zt41,zt12)
            zt48 = i-zt2
            t50 = sigma*u(zt48,zt12)
            t54 = t9*fnu(ndS,S,ndT,T,zt3,1,3,dt,dx,dy,theta)
            t55 = u(zt21,n)
            t56 = theta*t55
            t60 = t9*fnu(ndS,S,ndT,T,zt3,1,4,dt,dx,dy,theta)
            t61 = u(zt48,n)
            t62 = theta*t61
            t68 = sigma*u(zt31,zt12)
            t71 = u(i,n)
            t72 = theta*t71
            t81 = falphaa(zt3,1)
            zt105 = i-zt20-1
            t106 = u(zt105,n)
            t110 = t9*fnu(ndS,S,ndT,T,zt3,1,1,dt,dx,dy,theta)
            t116 = sigma*u(zt105,zt12)
            zt121 = i-zt2-1
            t122 = u(zt121,n)
            t123 = theta*t122
            t130 = t1*t81
            zt133 = n-1
            t134 = u(zt21,zt133)
            t136 = t7*t9
            t148 = t9*fnu(ndS,S,ndT,T,zt6,2,3,dt,dx,dy,theta)
            t157 = t9*fnu(ndS,S,ndT,T,zt6,2,4,dt,dx,dy,theta)
            t159 = sigma*u(zt121,zt12)
            t168 = theta*t106
            t172 = t9*fnu(ndS,S,ndT,T,zt6,2,2,dt,dx,dy,theta)
            t175 = u(zt41,n)
            t176 = theta*t175
            t180 = t9*fnu(ndS,S,ndT,T,zt6,2,1,dt,dx,dy,theta)
            t194 = falphaa(zt6,2)
            zt201 = n1-1
            t209 = t1*t194
            t212 = u(zt105,zt133)
            do   irr   =   1   ,   ndT   ,   1
               t11 = t9*dTfnu(ndS,S,ndT,T,zt3,1,1,dt,dx,dy,theta,irr)
               t18 = t9*dTfnu(ndS,S,ndT,T,zt3,1,3,dt,dx,dy,theta,irr)
               t26 = dfT(ndT,T,zt3,irr)
               t28 = t1*t26*t7
               t40 = t9*dTfnu(ndS,S,ndT,T,zt6,2,1,dt,dx,dy,theta,irr)
               t47 = t9*dTfnu(ndS,S,ndT,T,zt3,1,4,dt,dx,dy,theta,irr)
               t66 = t9*dTfnu(ndS,S,ndT,T,zt3,1,2,dt,dx,dy,theta,irr)
               t82 = t1*dTfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t81
               t87 = 
     &              t8*t11*t14
     &              +t8*t18*t23
     &              +t28*t30*t33
     &              +t38*t40*t43
     &              +t8*t47*t50
     &              +t28*t54*t56
     &              +t28*t60*t62
     &              +t8*t66*t68
     &              +t8*t11*t72
     &              +t8*t18*t56
     &              +t8*t47*t62
     &              +t82*t7*theta*q(zt21,n1)
               t100 = dfT(ndT,T,zt6,irr)
               t102 = t1*t100*t7
               t114 = t9*dTfnu(ndS,S,ndT,T,zt6,2,3,dt,dx,dy,theta,irr)
               t120 = t9*dTfnu(ndS,S,ndT,T,zt6,2,4,dt,dx,dy,theta,irr)
               t127 = t9*dTfnu(ndS,S,ndT,T,zt6,2,2,dt,dx,dy,theta,irr)
               t151 = 
     &              -t28*t9*fAinv(zt3,1,4)*t61
     &              -t28*t9*fAinv(zt3,1,2)*t32
     &              -t28*t9*fAinv(zt3,1,1)*t71
     &              -t102*t9*fAinv(zt6,2,3)*t106
     &              +t28*t110*t14
     &              +t38*t114*t116
     &              +t38*t120*t123
     &              +t38*t127*t14
     &              +t130*t4
     &              *dTfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &              *t134*t136
     &              -t102*t9*fAinv(zt6,2,4)*t122
     &              -t102*t9*fAinv(zt6,2,2)*t71
     &              +t102*t148*t116
               t189 = 
     &              gdT(irr)*t7*t9
     &              +t102*t157*t159
     &              +t28*t60*t50
     &              +t38*t127*t72
     &              +t38*t120*t159
     &              +t38*t114*t168
     &              +t102*t172*t14
     &              +t38*t40*t176
     &              +t102*t180*t176
     &              +t102*t180*t43
     &              +t102*t148*t168
     &              +t28*t110*t72
               t195 = t1*dTfbeta(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)
     &              *t194
               t242 = 
     &              t28*t54*t23
     &              +t195*t9*theta*q(zt105,n1)
     &              +t195*t9*sigma*q(zt105,zt201)
     &              +t28*t30*t68
     &              +t8*t66*t33
     &              +t209*t36
     &              *dTfgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta,irr)
     &              *t212*t136
     &              +t209*t100
     &              *fgamma(ndS,S,ndT,T,zt6,dt,dx,dy,theta)*t212*t136
     &              +t130*t26
     &              *fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*t134*t136
     &              -t28*t9*fAinv(zt3,1,3)*t55
     &              +t102*t157*t123
     &              +t102*t172*t72
     &              -t102*t9*fAinv(zt6,2,1)*t175
     &              +t82*t7*sigma*q(zt21,zt201)
               gdT(irr) = (t87+t151+t189+t242)/t7/t9
            enddo
         enddo
c     .....................
         i = nx*(ny+1)+j*nx
         t1 = vvzz(i)
         zt2 = nx*ny
         zt3 = i-zt2-nx-1
         t4 = falphaa(zt3,2)
         t6 = fT(ndT,T,zt3)
         zt10 = nx*(ny+1)
         zt11 = i-zt10-1
         zt12 = n-1
         t15 = falphak(zt3)
         zt16 = i-zt2-nx
         t17 = falphak(zt16)
         t18 = t15*t17
         t21 = falphaa(zt16,1)
         t23 = fT(ndT,T,zt16)
         zt26 = i-zt10
         zt35 = n1-1
         t55 = t1*t6*t15
         zt58 = i-zt2-1
         zt59 = n-2
         zt81 = i-1
         t93 = sigma*u(i,zt59)
         t97 = theta*u(i,n)
         t101 = t1*t23*t15
         zt104 = i-zt2
         do   irr   =   1   ,   ndS   ,   1
            t33 = t1*dSfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t4
            t45 = t1*dSfbeta(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)*t21
            t57 = t17*dSfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
            t69 = t17*dSfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
            t80 = t17*dSfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
            t91 = t17*dSfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
            t103 = t17*dSfnu(ndS,S,ndT,T,zt16,1,4,dt,dx,dy,theta,irr)
            t114 = t17*dSfnu(ndS,S,ndT,T,zt16,1,3,dt,dx,dy,theta,irr)
            t124 = t17*dSfnu(ndS,S,ndT,T,zt16,1,1,dt,dx,dy,theta,irr)
            t132 = 
     &           t55*t80*sigma*u(zt81,zt59)
     &           +t55*t80*theta*u(zt81,n)
     &           +t55*t91*t93
     &           +t55*t91*t97
     &           +t101*t103*sigma*u(zt104,zt59)
     &           +t101*t103*theta*u(zt104,n)
     &           +t101*t114*sigma*u(zt26,zt59)
     &           +t101*t114*theta*u(zt26,n)
     &           +t101*t124*t93
     &           +t101*t124*t97
     &           +gdS(irr)*t15*t17
            gdS(irr) = (
     &           t1*t4*t6
     &           *dSfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &           *u(zt11,zt12)*t18
     &           +t1*t21*t23
     &           *dSfgamma(ndS,S,ndT,T,zt16,dt,dx,dy,theta,irr)
     &           *u(zt26,zt12)*t18
     &           +t33*t17*sigma*q(zt11,zt35)
     &           +t33*t17*theta*q(zt11,n1)
     &           +t45*t15*sigma*q(zt26,zt35)
     &           +t45*t15*theta*q(zt26,n1)
     &           +t55*t57*sigma*u(zt58,zt59)
     &           +t55*t57*theta*u(zt58,n)
     &           +t55*t69*sigma*u(zt11,zt59)
     &           +t55*t69*theta*u(zt11,n)+t132)/t15/t17
         enddo
         i = nx*(ny+1)+j*nx
         t1 = vvzz(i)
         zt2 = nx*ny
         zt3 = i-zt2-nx-1
         t6 = falphak(zt3)
         zt8 = i-zt2-nx
         t9 = falphak(zt8)
         zt12 = i-zt2-1
         t13 = u(zt12,n)
         t17 = t9*fnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta)
         zt18 = n-2
         t20 = sigma*u(zt12,zt18)
         t24 = t9*fnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta)
         t25 = u(i,n)
         t26 = theta*t25
         zt34 = i-zt2
         t35 = u(zt34,n)
         t40 = falphaa(zt8,1)
         zt44 = nx*(ny+1)
         zt45 = i-zt44
         t49 = t1*t40
         zt52 = n-1
         t53 = u(zt45,zt52)
         t55 = t6*t9
         t58 = falphaa(zt3,2)
         t59 = t1*t58
         t60 = fT(ndT,T,zt3)
         zt63 = i-zt44-1
         t64 = u(zt63,zt52)
         zt79 = i-1
         t80 = u(zt79,n)
         t85 = u(zt63,n)
         t89 = fT(ndT,T,zt8)
         t99 = sigma*u(i,zt18)
         t103 = t9*fnu(ndS,S,ndT,T,zt8,1,1,dt,dx,dy,theta)
         t108 = theta*t13
         t112 = t1*t60*t6
         t115 = theta*t80
         t124 = u(zt45,n)
         t132 = t9*fnu(ndS,S,ndT,T,zt8,1,4,dt,dx,dy,theta)
         t134 = sigma*u(zt34,zt18)
         t146 = t9*fnu(ndS,S,ndT,T,zt8,1,3,dt,dx,dy,theta)
         t148 = sigma*u(zt45,zt18)
         t151 = theta*t35
         t155 = t9*fnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta)
         t157 = sigma*u(zt63,zt18)
         t160 = theta*t124
         t164 = t1*t89*t6
         t170 = t9*fnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta)
         t174 = sigma*u(zt79,zt18)
         t177 = theta*t85
         zt201 = n1-1
         do   irr   =   1   ,   ndT   ,   1
            t4 = dfT(ndT,T,zt3,irr)
            t7 = t1*t4*t6
            t29 = dfT(ndT,T,zt8,irr)
            t31 = t1*t29*t6
            t41 = t1*dTfbeta(ndS,S,ndT,T,zt8,dt,dx,dy,theta,irr)*t40
            t88 = 
     &           -t7*t9*fAinv(zt3,2,4)*t13
     &           +t7*t17*t20
     &           +t7*t24*t26
     &           -t31*t9*fAinv(zt8,1,4)*t35
     &           +t41*t6*theta*q(zt45,n1)
     &           +t49*t29*fgamma(ndS,S,ndT,T,zt8,dt,dx,dy,theta)*t53*t55
     &           +t59*t60*dTfgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)
     &           *t64*t55
     &           -t7*t9*fAinv(zt3,2,2)*t25
     &           +t59*t4*fgamma(ndS,S,ndT,T,zt3,dt,dx,dy,theta)*t64*t55
     &           -t7*t9*fAinv(zt3,2,1)*t80
     &           -t7*t9*fAinv(zt3,2,3)*t85
            t114 = t9*dTfnu(ndS,S,ndT,T,zt3,2,1,dt,dx,dy,theta,irr)
            t128 = t9*dTfnu(ndS,S,ndT,T,zt3,2,2,dt,dx,dy,theta,irr)
            t137 = 
     &           t49*t89*dTfgamma(ndS,S,ndT,T,zt8,dt,dx,dy,theta,irr)
     &           *t53*t55
     &           +gdT(irr)*t6*t9
     &           +t7*t24*t99
     &           +t31*t103*t26
     &           +t31*t103*t99
     &           +t7*t17*t108
     &           +t112*t114*t115
     &           -t31*t9*fAinv(zt8,1,1)*t25
     &           -t31*t9*fAinv(zt8,1,3)*t124
     &           +t112*t128*t99
     &           +t31*t132*t134
            t142 = t9*dTfnu(ndS,S,ndT,T,zt3,2,4,dt,dx,dy,theta,irr)
            t166 = t9*dTfnu(ndS,S,ndT,T,zt8,1,1,dt,dx,dy,theta,irr)
            t181 = t9*dTfnu(ndS,S,ndT,T,zt3,2,3,dt,dx,dy,theta,irr)
            t184 = 
     &           t112*t128*t26
     &           +t112*t142*t20
     &           +t31*t146*t148
     &           +t31*t132*t151
     &           +t7*t155*t157
     &           +t31*t146*t160
     &           +t164*t166*t26
     &           +t7*t170*t115
     &           +t7*t170*t174
     &           +t7*t155*t177
     &           +t112*t181*t157
            t188 = t9*dTfnu(ndS,S,ndT,T,zt8,1,4,dt,dx,dy,theta,irr)
            t199 = t1*dTfbeta(ndS,S,ndT,T,zt3,dt,dx,dy,theta,irr)*t58
            t208 = t9*dTfnu(ndS,S,ndT,T,zt8,1,3,dt,dx,dy,theta,irr)
            t221 = 
     &           t112*t142*t108
     &           +t164*t188*t151
     &           +t164*t188*t134
     &           +t112*t114*t174
     &           +t112*t181*t177
     &           +t199*t9*sigma*q(zt63,zt201)
     &           +t164*t166*t99
     &           +t164*t208*t160
     &           +t164*t208*t148
     &           +t199*t9*theta*q(zt63,n1)
     &           +t41*t6*sigma*q(zt45,zt201)
            gdT(irr) = (t88+t137+t184+t221)/t6/t9
         enddo
      enddo
c     ICI
c     ---------------------------------------------------------------
      j = ny+1
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         t1 = vvzz(i)
         zt2 = i-nx
         t3 = falphaa(zt2,4)
         t5 = fT(ndT,T,zt2)
         t11 = falphak(zt2)
         t26 = t1*t5*t11
         zt29 = n-2
         zt48 = nx*ny
         zt49 = zt48+i
         zt59 = zt48+i+1
         do   irr   =   1   ,   ndS   ,   1
            t15 = t1*dSfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
            t27 = dSfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
            t37 = dSfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
            t46 = dSfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
            t57 = dSfnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta,irr)
            t69 = 
     &           t1*t3*t5
     &           *dSfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &           *u(zt2,n-1)*t11
     &           +t15*t3*sigma*q(zt2,n1-1)
     &           +t15*t3*theta*q(zt2,n1)
     &           +t26*t27*sigma*u(i,zt29)
     &           +t26*t27*theta*u(i,n)
     &           +t26*t37*sigma*u(zt2,zt29)
     &           +t26*t37*theta*u(zt2,n)
     &           +t26*t46*sigma*u(zt49,zt29)
     &           +t26*t46*theta*u(zt49,n)
     &           +t26*t57*sigma*u(zt59,zt29)
     &           +t26*t57*theta*u(zt59,n)
     &           +gdS(irr)*t11
            gdS(irr) = t69/t11
         enddo
      enddo
      do   i   =   (j-1)*nx+1   ,   j*nx-1   ,   1
         t1 = vvzz(i)
         zt2 = i-nx
         t5 = falphaa(zt2,4)
         t12 = falphak(zt2)
         t14 = fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)
         zt16 = n-2
         t17 = u(zt2,zt16)
         t25 = t1*t5
         t26 = fT(ndT,T,zt2)
         t30 = u(zt2,n-1)
         t41 = u(zt2,n)
         t46 = u(i,n)
         t52 = fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)
         t57 = t1*t26*t12
         t63 = u(i,zt16)
         t74 = fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)
         zt76 = nx*ny
         zt77 = zt76+i
         t78 = u(zt77,zt16)
         zt87 = zt76+i+1
         t88 = u(zt87,zt16)
         t91 = fnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta)
         t93 = u(zt87,n)
         t105 = u(zt77,n)
         do   irr   =   1   ,   ndT   ,   1
            t4 = t1*dTfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
            t10 = dfT(ndT,T,zt2,irr)
            t11 = t1*t10
            t13 = t11*t12
            t58 = dTfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
            t66 = dTfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
            t70 = 
     &           t4*t5*theta*q(zt2,n1)
     &           +t13*t14*sigma*t17
     &           +t4*t5*sigma*q(zt2,n1-1)
     &           +t25*t26
     &           *dTfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t30*t12
     &           +t25*t10
     &           *fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*t30*t12
     &           -t11*t12*fAinv(zt2,4,3)*t41
     &           -t11*t12*fAinv(zt2,4,4)*t46
     &           +t13*t14*theta*t41
     &           +t13*t52*theta*t46
     &           +t57*t58*theta*t41
     &           +t13*t52*sigma*t63
     &           +t57*t66*theta*t46
            t81 = dTfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
            t85 = dTfnu(ndS,S,ndT,T,zt2,4,2,dt,dx,dy,theta,irr)
            t122 = 
     &           t57*t58*sigma*t17
     &           +t13*t74*sigma*t78
     &           +t57*t81*sigma*t78
     &           +t57*t85*sigma*t88
     &           +t13*t91*theta*t93
     &           +gdT(irr)*t12
     &           +t13*t91*sigma*t88
     &           +t57*t85*theta*t93
     &           +t57*t81*theta*t105
     &           -t11*t12*fAinv(zt2,4,2)*t93
     &           +t57*t66*sigma*t63
     &           -t11*t12*fAinv(zt2,4,1)*t105
     &           +t13*t74*theta*t105
            gdT(irr) = (t70+t122)/t12
         enddo
      enddo
c     .....................
      i = j*nx
      t1 = vvzz(i)
      zt2 = i-nx
      t3 = falphaa(zt2,4)
      t5 = fT(ndT,T,zt2)
      t11 = falphak(zt2)
      t26 = t1*t5*t11
      zt29 = n-2
      zt49 = nx*ny+i
      do   irr   =   1   ,   ndS   ,   1
         t15 = t1*dSfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
         t27 = dSfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
         t37 = dSfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
         t46 = dSfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
         gdS(irr) = (
     &        t1*t3*t5
     &        *dSfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
     &        *u(zt2,n-1)*t11
     &        +t15*t3*sigma*q(zt2,n1-1)
     &        +t15*t3*theta*q(zt2,n1)
     &        +t26*t27*sigma*u(i,zt29)
     &        +t26*t27*theta*u(i,n)
     &        +t26*t37*sigma*u(zt2,zt29)
     &        +t26*t37*theta*u(zt2,n)
     &        +t26*t46*sigma*u(zt49,zt29)
     &        +t26*t46*theta*u(zt49,n)
     &        +gdS(irr)*t11)/t11
      enddo
      i = j*nx
      t1 = vvzz(i)
      zt2 = i-nx
      t3 = falphaa(zt2,4)
      t4 = t1*t3
      t9 = u(zt2,n-1)
      t11 = falphak(zt2)
      t14 = fT(ndT,T,zt2)
      t33 = fnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta)
      zt35 = n-2
      t36 = u(i,zt35)
      t40 = u(i,n)
      t43 = fnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta)
      t45 = u(zt2,zt35)
      t49 = u(zt2,n)
      t52 = fnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta)
      zt55 = nx*ny+i
      t56 = u(zt55,zt35)
      t60 = u(zt55,n)
      t76 = t1*t14*t11
      do   irr   =   1   ,   ndT   ,   1
         t5 = dfT(ndT,T,zt2,irr)
         t21 = t1*dTfbeta(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)
         t31 = t1*t5
         t32 = t31*t11
         t77 = dTfnu(ndS,S,ndT,T,zt2,4,4,dt,dx,dy,theta,irr)
         t84 = dTfnu(ndS,S,ndT,T,zt2,4,3,dt,dx,dy,theta,irr)
         t91 = dTfnu(ndS,S,ndT,T,zt2,4,1,dt,dx,dy,theta,irr)
         t100 = 
     &        t4*t5*fgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta)*t9*t11
     &        +t4*t14
     &        *dTfgamma(ndS,S,ndT,T,zt2,dt,dx,dy,theta,irr)*t9*t11
     &        +t21*t3*sigma*q(zt2,n1-1)
     &        +t21*t3*theta*q(zt2,n1)
     &        +t32*t33*sigma*t36
     &        +t32*t33*theta*t40
     &        +t32*t43*sigma*t45
     &        +t32*t43*theta*t49
     &        +t32*t52*sigma*t56
     &        +t32*t52*theta*t60
     &        -t31*t11*fAinv(zt2,4,4)*t40
     &        -t31*t11*fAinv(zt2,4,3)*t49
     &        -t31*t11*fAinv(zt2,4,1)*t60
     &        +t76*t77*sigma*t36
     &        +t76*t77*theta*t40
     &        +t76*t84*sigma*t45
     &        +t76*t84*theta*t49
     &        +t76*t91*sigma*t56
     &        +t76*t91*theta*t60
     &        +gdT(irr)*t11
         gdT(irr) = t100/t11
      enddo
      return
      end
