CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright (c) 2013-2014 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: init_model.f,v 1.4 2014/05/12 14:43:23 fclement Exp $

      subroutine init_model(size_x_p, size_y_p, ndS, S,
     +     ier, emsg_length, error_msg)
      
      implicit none
      
      include 'common.fh'
      
C     Output arguments.
      character*80 error_msg
      integer size_x_p, size_y_p, ndS, ier, emsg_length
      real*8 S(*)
      
C     Local variable.
      integer ncells
      
      ier = 0
      
      call init_scheme(ncells, ndS, S, ier, emsg_length, error_msg)
      if (ier .ne. 0) then
         return
      endif
      
      size_x_p = nx
      size_y_p = ny
      
      call init_measures(ncells, ier, emsg_length, error_msg)
      if (ier .ne. 0) then
         return
      endif
      
      call init_optim(ier, emsg_length, error_msg)
      if (ier .ne. 0) then
         return
      endif
      
      return
      end
